import { LRLanguage, LanguageDescription, LanguageSupport } from "@codemirror/language";
import { Tag } from "@lezer/highlight";
declare const mermaidLanguage: LRLanguage;
declare const mindmapLanguage: LRLanguage;
declare const pieLanguage: LRLanguage;
declare const flowchartLanguage: LRLanguage;
declare const sequenceLanguage: LRLanguage;
declare const journeyLanguage: LRLanguage;
declare const mermaidLanguageDescription: LanguageDescription;
declare const mindmapLanguageDescription: LanguageDescription;
declare const pieLanguageDescription: LanguageDescription;
declare const flowchartLanguageDescription: LanguageDescription;
declare const sequenceLanguageDescription: LanguageDescription;
declare const journeyLanguageDescription: LanguageDescription;
declare function mermaid(): LanguageSupport;
declare function mindmap(): LanguageSupport;
declare function pie(): LanguageSupport;
declare function flowchart(): LanguageSupport;
declare function sequence(): LanguageSupport;
declare function journey(): LanguageSupport;
declare const mermaidTags: {
    diagramName: Tag;
};
declare const mindmapTags: {
    diagramName: Tag;
    lineText1: Tag;
    lineText2: Tag;
    lineText3: Tag;
    lineText4: Tag;
    lineText5: Tag;
};
declare const pieTags: {
    diagramName: Tag;
    lineComment: Tag;
    number: Tag;
    showData: Tag;
    string: Tag;
    title: Tag;
    titleText: Tag;
};
declare const flowchartTags: {
    diagramName: Tag;
    keyword: Tag;
    lineComment: Tag;
    link: Tag;
    nodeEdge: Tag;
    nodeEdgeText: Tag;
    nodeId: Tag;
    nodeText: Tag;
    number: Tag;
    orientation: Tag;
    string: Tag;
};
declare const sequenceTags: {
    diagramName: Tag;
    arrow: Tag;
    keyword1: Tag;
    keyword2: Tag;
    lineComment: Tag;
    messageText1: Tag;
    messageText2: Tag;
    nodeText: Tag;
    position: Tag;
};
declare const journeyTags: {
    diagramName: Tag;
    actor: Tag;
    keyword: Tag;
    lineComment: Tag;
    score: Tag;
    text: Tag;
};
export { mermaidLanguage, mindmapLanguage, pieLanguage, flowchartLanguage, sequenceLanguage, journeyLanguage, mermaidLanguageDescription, mindmapLanguageDescription, pieLanguageDescription, flowchartLanguageDescription, sequenceLanguageDescription, journeyLanguageDescription, mermaid, mindmap, pie, flowchart, sequence, journey, mermaidTags, mindmapTags, pieTags, flowchartTags, sequenceTags, journeyTags };
